template <typename T,
	  typename NonRefT = typename std::decay<T>::type>
NonRefT foo(T&& a, T&& b, T&& c) {
  assert_concept(monoid<NonRefT, op_plus,
			wrapped_constructor<NonRefT()> >());

  NonRefT ret = std::forward<T>(a) +
    std::forward<T>(b) + std::forward<T>(c);
  return ret;
}
